﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote73_ImageResource_CS
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }

        private Bitmap imgChange1;    // SmartButton.ImageUp에 적용할 이미지1
        private Bitmap imgChange2;    // SmartButton.ImageUp에 적용할 이미지2
        private bool m_bFlag;           // 변경할 버튼의 이미지를 지정하기 위한 플래그

        private void Form2_Load(object sender, EventArgs e)
        {
            // 멤버 변수 초기화
            m_bFlag = false;

            // 이미지를 인스턴싱
            imgChange1 = new Bitmap(Properties.Resources._1_off);
            imgChange2 = new Bitmap(Properties.Resources._2_off);

            // SmartUpDown 버튼 설정
            udButtonCount.SpecialFunction = SmartX.SmartButton.SPECIALFUNC.REPT;
            udButtonCount.RepeatInterval = 100;

            // 버튼의 연속클릭을 방지하기 위한 설정
            btnChange.SpecialFunction = SmartX.SmartButton.SPECIALFUNC.SAFE;
            btnChange.SafeInterval = 1;
        }

        // 체크박스 클릭 시 텍스트 변경
        private void chkUpgrade_Click(object sender, EventArgs e)
        {
            if (chkUpgrade.Checked == false) { chkUpgrade.Text = "개선 전"; }
            else { chkUpgrade.Text = "개선 후"; }
        }

        // 버튼 이미지 일괄변경 메서드
        private void btnChange_Click(object sender, EventArgs e)
        {
            int iRep = (int)udButtonCount.Value;

            // 시간 체크 시작
            SmartX.SmartTimer.StartWatch();

            // 리소스에서 바로 호출하는 방식(개선 전 방식)
            if (chkUpgrade.Checked == false)
            {
                // 버튼을 지정한 개수만큼 업이미지를 일괄 변경. 테크노트41번 참고
                for (int i = 1; i <= iRep; i++)
                {
                    ("smartButton" + i).ControlByName<SmartX.SmartButton>(this).ImageUp = (m_bFlag == false) ? Properties.Resources._2_off : Properties.Resources._1_off;
                    ("smartButton" + i).ControlByName<SmartX.SmartButton>(this).ImageDown = (m_bFlag == false) ? Properties.Resources._2_on : Properties.Resources._1_on;
                }

                // 시간체크 정지하고 라벨에 출력
                SmartX.SmartTimer.StopWatch();
                labBeforeTime.Text = SmartX.SmartTimer.StopWatchElapsedSecond.ToString("0.000초");
            }
            // 이미지를 인스턴스화 한 후 호출하는 방식(개선 후 방식)
            else
            {
                // 버튼을 지정한 개수만큼 업이미지를 일괄 변경. 테크노트41번 참고
                for (int i = 1; i <= iRep; i++)
                {
                    ("smartButton" + i).ControlByName<SmartX.SmartButton>(this).ImageUp = (m_bFlag == false) ? imgChange2 : imgChange1;
                }

                // 시간체크 정지하고 라벨에 출력
                SmartX.SmartTimer.StopWatch();
                labAfterTime.Text = SmartX.SmartTimer.StopWatchElapsedSecond.ToString("0.000초");
            }

            // 변경할 버튼의 이미지를 지정하기 위한 플래그설정
            m_bFlag = (m_bFlag == false) ? true : false;
        }

        private void btmMainForm_Click(object sender, EventArgs e)
        {
            smartForm1.Show(0);
        }
    }

    // 문자열 값을 다른 데이터 값으로 변경하기위해서 유용한 메서드 제공 테크노트41번 참고
    public static class StringExtensinos
    {
        // 동적 배열을 위해 리스트 사용
        public static T ControlByName<T>(this string name, object targetClass) where T : class
        {
            // 필드의 특성을 검색하고 필드 메타데이터에 엑세스할 수 있도록 함. 클래스의 구조파악(GetType, GetField). Get the FieldInfo.
            System.Reflection.FieldInfo fi = targetClass.GetType().GetField(name, System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic);
            return fi.GetValue(targetClass) as T;
        }

        // 동적 배열을 위해 리스트 사용
        public static T ControlByName<T>(object targetClass, string name) where T : class
        {
            // 필드의 특성을 검색하고 필드 메타데이터에 엑세스할 수 있도록 함. 클래스의 구조파악(GetType, GetField). Get the FieldInfo.
            System.Reflection.FieldInfo fi = targetClass.GetType().GetField(name, System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic);
            return fi.GetValue(targetClass) as T;
        }
    }
}