﻿Public Class Form1

    ' 비트맵 배열의 인덱스를 체크
    Private m_iIndex As Integer
    ' 현재 반복 횟수를 체크
    Private m_iRep As Integer
    ' 콤보박스에서 설정한 반복 횟수
    Private m_iReptCnt As Integer

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        ' 현재Form을 MainForm으로 설정
        SmartForm1.MainForm = Me

        ' 멤버 변수 초기화
        m_iIndex = 0
        m_iRep = 0

        ' SmartTimer의 Interval = 1
        SmartTimer1.Interval = 1
        SmartTimer2.Interval = 1

        ' 콤보박스에 아이템을 추가하고 기본값을 1000으로 설정
        cbRepeatCount.ItemList.AddItem("500")
        cbRepeatCount.ItemList.AddItem("1000")
        cbRepeatCount.ItemList.AddItem("2000")
        cbRepeatCount.SelectItemIndex = 1

        ' MainForm을 출력
        SmartMemory1.MemoryStatusInformationShow(SmartX.SmartMemory.VIEWPOSITION.BOTTOMLEFT)
    End Sub

    ' Form이 로딩될 때 이미지를 인스턴싱
    Private Sub smartForm1_OnFormLoadCompleting() Handles SmartForm1.OnFormLoadCompleting
        ' 이미지 인스턴싱 시간을 체크
        SmartX.SmartTimer.StartWatch()

        ' 사용 이미지 10개
        smartPictureBox1.AddImageList(My.Resources._0)
        smartPictureBox1.AddImageList(My.Resources._1)
        smartPictureBox1.AddImageList(My.Resources._2)
        smartPictureBox1.AddImageList(My.Resources._3)
        smartPictureBox1.AddImageList(My.Resources._4)
        smartPictureBox1.AddImageList(My.Resources._5)
        smartPictureBox1.AddImageList(My.Resources._6)
        smartPictureBox1.AddImageList(My.Resources._7)
        smartPictureBox1.AddImageList(My.Resources._8)
        smartPictureBox1.AddImageList(My.Resources._9)

        ' 시간 측정 종료
        SmartX.SmartTimer.StopWatch()
    End Sub

    ' Form 로딩이 완료되었을 때 인스턴싱 경과시간을 표시
    Private Sub smartForm1_OnFormLoadCompleted() Handles SmartForm1.OnFormLoadCompleted
        labInstance.Text = SmartX.SmartTimer.StopWatchElapsedSecond.ToString("0.00초")
    End Sub

    ' 체크박스 클릭 시 텍스트 변경
    Private Sub chkUpgrade_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chkUpgrade.Click
        If chkUpgrade.Checked = False Then
            chkUpgrade.Text = "개선 전"
        Else
            chkUpgrade.Text = "개선 후"
        End If
    End Sub

    ' 버튼 클릭에 대한 이벤트
    Private Sub SmartButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnTimeCheck.Click, btnStartEnd.Click, btnNextForm.Click
        If sender Is btnTimeCheck Then
            ' 클릭한 버튼이 [시간 체크] 이미지를 지정한 횟수만큼 반복하고 시간을 측정합니다. : Push Button

            ' [출력시작] 버튼이 눌려있다면 출력을 정지한다.
            If btnStartEnd.ButtonStatus = SmartX.SmartButton.BUTSTATUS.DOWN Then
                SmartTimer1.Stop()
            End If

            btnTimeCheck.Enabled = False
            ' 현재 반복 횟수를 초기화
            m_iRep = 0
            ' 반복 횟수를 콤보박스에서 선택한 값으로 설정
            m_iReptCnt = Convert.ToInt32(cbRepeatCount.Text)
            ' 반복 시작
            SmartTimer2.Start()
            ' 리소스에서 바로 출력시 시간 측정 시작
            SmartX.SmartTimer.StartWatch()
        ElseIf sender Is btnStartEnd Then
            ' 클릭한 버튼이 [출력시작] 시간을 측정하지 않는 이미지 출력을 시작/정지합니다. : Push Button

            If btnStartEnd.ButtonStatus = SmartX.SmartButton.BUTSTATUS.UP Then
                SmartTimer1.Stop()
            Else
                ' 시간을 체크하지 않는 이미지 반복 출력
                SmartTimer1.Start()
            End If
        Else
            ' 클릭한 버튼이 [다음 폼]
            SmartX.SmartMessageBox.Show("VB.NET에서는 버튼 개수별 이미지 변경 관련 예제는 제공되지 않습니다.")
        End If
    End Sub

    Private Sub smartTimer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer1.Tick
        ' 체크박스 체크 여부에 따라 출력 방식을 결정
        ShowImage(chkUpgrade.Checked)
    End Sub

    Private Sub smartTimer2_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles SmartTimer2.Tick
        If m_iRep < m_iReptCnt Then
            ' 리소스에서 불러오는 방식을 먼저 실행
            ShowImage(False)
        Else
            ' 설정한 반복 횟수 이후 객체에서 불러오는 방식을 실행
            ShowImage(True)
        End If

        If System.Threading.Interlocked.Increment(m_iRep) = m_iReptCnt Then
            ' 반복횟수를 증가시키고 설정한 반복횟수가 되면 다음 방식의 시간체크를 시작

            ' 리소스에서 불러오는 방식의 시간체크를 종료하고 라벨에 시간을 표시
            SmartX.SmartTimer.StopWatch()
            labBeforeTime.Text = SmartX.SmartTimer.StopWatchElapsedSecond.ToString("0.00초")
            ' 객체에서 불러오는 방식의 시간체크 시작
            SmartX.SmartTimer.StartWatch()
        ElseIf m_iRep = (m_iReptCnt * 2) Then
            ' 현재 반복횟수가 설정한 반복횟수의 2배가 될 때 반복을 종료

            ' 객체에서 불러오는 방식의 시간체크를 종료하고 라벨에 시간 표시
            SmartX.SmartTimer.StopWatch()
            labAfterTime.Text = SmartX.SmartTimer.StopWatchElapsedSecond.ToString("0.00초")

            ' 반복이 완료되어 타이머를 정지하고 반복횟수를 초기화
            SmartTimer2.Stop()
            m_iRep = 0
            btnTimeCheck.Enabled = True
            btnTimeCheck.ButtonUp()
        End If
    End Sub

    ' 이미지를 SmartPictureBox에 출력하는 메서드(인자값 : 개선 전, 후 체크)
    Private Sub ShowImage(ByVal bSelect As Boolean)
        If bSelect = False Then
            ' 리소스에서 바로 호출하는 방식 [개선 전 방식]

            ' 현재 인덱스에 맞는 이미지를 리소스에서 바로 출력
            Select Case m_iIndex
                Case 0
                    smartPictureBox1.Image = My.Resources._0
                Case 1
                    smartPictureBox1.Image = My.Resources._1
                Case 2
                    smartPictureBox1.Image = My.Resources._2
                Case 3
                    smartPictureBox1.Image = My.Resources._3
                Case 4
                    smartPictureBox1.Image = My.Resources._4
                Case 5
                    smartPictureBox1.Image = My.Resources._5
                Case 6
                    smartPictureBox1.Image = My.Resources._6
                Case 7
                    smartPictureBox1.Image = My.Resources._7
                Case 8
                    smartPictureBox1.Image = My.Resources._8
                Case 9
                    smartPictureBox1.Image = My.Resources._9
                Case Else
            End Select
        Else
            ' 이미지를 인스턴스화 한 후 호출하는 방식(개선 후 방식)
            smartPictureBox1.DrawNext()
        End If

        ' 이미지의 인덱스를 증가시키고 마지막 값이 된 경우 초기화
        m_iIndex = If((m_iIndex = 9), 0, System.Threading.Interlocked.Increment(m_iIndex))
    End Sub
End Class
